from datetime import datetime

from pydantic import BaseModel


class TagBase(BaseModel):
    name: str
    slug: str

class TagCreate(TagBase):
    pass

class TagUpdate(BaseModel):
    name: str | None = None
    slug: str | None = None

class TagInDBBase(TagBase):
    id: str
    created_at: datetime
    updated_at: datetime | None = None

    class Config:
        orm_mode = True

class Tag(TagInDBBase):
    pass

class TagWithProductCount(Tag):
    product_count: int = 0
